【CodeForces - 144D】Missile Silos(单源最短路,枚举中间边,枚举情况可能性)

版权声明:欢迎学习我的博客,希望ACM的发展越来越好~ https://blog.csdn.net/qq_41289920/article/details/83052279

题干:

A country called Berland consists of n cities, numbered with integer numbers from 1to n. Some of them are connected by bidirectional roads. Each road has some length. There is a path from each city to any other one by these roads. According to some Super Duper Documents, Berland is protected by the Super Duper Missiles. The exact position of the Super Duper Secret Missile Silos is kept secret but Bob managed to get hold of the information. That information says that all silos are located exactly at a distance l from the capital. The capital is located in the city with number s.

The documents give the formal definition: the Super Duper Secret Missile Silo is located at some place (which is either city or a point on a road) if and only if the shortest distance from this place to the capital along the roads of the country equals exactly l.

Bob wants to know how many missile silos are located in Berland to sell the information then to enemy spies. Help Bob.

Input

The first line contains three integers nm and s (2 ≤ n ≤ 105, , 1 ≤ s ≤ n) — the number of cities, the number of roads in the country and the number of the capital, correspondingly. Capital is the city no. s.

Then m lines contain the descriptions of roads. Each of them is described by three integers viuiwi (1 ≤ vi, ui ≤ nvi ≠ ui, 1 ≤ wi ≤ 1000), where viui are numbers of the cities connected by this road and wi is its length. The last input line contains integer l (0 ≤ l ≤ 109) — the distance from the capital to the missile silos. It is guaranteed that:

  • between any two cities no more than one road exists;
  • each road connects two different cities;
  • from each city there is at least one way to any other city by the roads.

Output

Print the single number — the number of Super Duper Secret Missile Silos that are located in Berland.

Examples

Input

4 6 1
1 2 1
1 3 3
2 3 1
2 4 1
3 4 1
1 4 2
2

Output

3

Input

5 6 3
3 1 1
3 2 1
3 4 1
3 5 1
1 2 6
4 5 8
4

Output

3

Note

In the first sample the silos are located in cities 3 and 4 and on road (1, 3) at a distance 2 from city 1 (correspondingly, at a distance 1 from city 3).

In the second sample one missile silo is located right in the middle of the road (1, 2). Two more silos are on the road (4, 5) at a distance 3 from city 4 in the direction to city 5 and at a distance 3 from city 5 to city 4.

题目大意:

     图中有n个点,m条无向边,一个起点,问有距离原点最短距离为l的地方有几个(在边上或者在点上都算)。

解题报告:

   这题思路还是很清晰的啊,但是1WA了因为开数组应该是2e5,因为是无向图啊!!我记得之前就在这错过。

  首先把在点上的处理了,然后枚举每一条边分四种情况分别列出来,其中最后一种再分三种情况列出来就好了:

1.先可以设定的点在u,v中间,

2.可以设定的点更加靠近u,这样只需要满足求出的那个点,经过v再到原点的距离>L 就可以ans++了;

3.可以设定的点更加靠近v,这样只需要满足求出的那个点,经过u到原点的距离>L就可以ans++了。

对应将三种情况分别枚举出来,维护ans即可。(2和3比较难绕,但是可以从答案贡献的角度反面考虑,就不难证明正确性。)

AC代码:

#include<cstdio>
#include<queue>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;
const int MAX = 2e5 +5;
const int INF = 0x3f3f3f3f;
int n,m,s;
int id,ans;
int head[MAX];
int dis[MAX];
bool vis[MAX];
struct Node {
	int fm,to,w;
	int ne;
} e[MAX];
struct Point {
	int pos;
	int c;
	Point(){}
	Point(int pos,int c):pos(pos),c(c){}
	bool operator <(const Point & b) const {
		return c > b.c;
	}
};
void add(int u,int v,int w) {
	e[++id].fm=u;
	e[id].to = v;
	e[id].w = w;
	e[id].ne = head[u];
	head[u] = id;
}
void Dijkstra(int u) {
	memset(dis,INF,sizeof dis);
	dis[u] = 0;
	memset(vis,0,sizeof vis);
	priority_queue<Point> pq;
	pq.push(Point(u,0));
	while(!pq.empty()) {
		Point cur = pq.top();pq.pop();
		if(vis[cur.pos] == 1) continue;
		vis[cur.pos] = 1;
		for(int i = head[cur.pos]; i!=-1; i=e[i].ne) {
			if(vis[e[i].to]) continue;
			if(dis[e[i].to] > dis[cur.pos] + e[i].w) {
				dis[e[i].to] = dis[cur.pos] + e[i].w;
				pq.push(Point(e[i].to,dis[e[i].to]));
			}
		}
	}
}
int main()
{
	cin>>n>>m>>s;
	memset(head,-1,sizeof head);
	ans = 0;
	int a,b,w,L;
	for(int i = 1; i<=m; i++) {
		scanf("%d%d%d",&a,&b,&w);
		add(a,b,w);
		add(b,a,w);
	}
	cin>>L;
	Dijkstra(s);
	for(int i = 1; i<=n; i++) {
		if(dis[i] == L) ans++;
	}
	//枚举每一条边 
	for(int i = 1; i<=id; i+=2) {
		int u = e[i].fm,v = e[i].to,w = e[i].w;
		if(dis[u] >= L && dis[v] >= L) continue;
		if(dis[u] >= L && dis[v] <  L) {
			if(dis[v] + w > L) ans++; 
		}
		else if(dis[v] >=L && dis[u] < L) {
			if(dis[u] + w > L) ans++;
		}
		else {
			int disu = L - dis[u],disv = L - dis[v];//计算一下多出来的那一块
			if(disu + disv == w) ans++;
			else {
				if(disu < w && dis[v] + (w-disu) > L) ans++;//别忘了disu < w
				if(disv < w && dis[u] + (w-disv) > L) ans++; 
			}
		}
	}
	printf("%d\n",ans);
	return 0 ;
}

猜你喜欢

转载自blog.csdn.net/qq_41289920/article/details/83052279